using Root.Reports;
using System;

// Creation date: 07.11.2004
// Checked: 08.11.2004
// Author: Otto Mayer (mot@root.ch)
// Version: 1.03

// Report.NET copyright 2002-2004 root-software ag, Brglen Switzerland - Otto Mayer, Stefan Spirig, all rights reserved
// This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License

// as published by the Free Software Foundation, version 2.1 of the License.

// This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of

// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details. You

// should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software

// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA www.opensource.org/licenses/lgpl-license.html

namespace ReportSamplesASP {
  /// <summary>
  /// The <b>ReportSamplesASP</b> namespace contains sample classes that demonstrate the usage of the Report.NET library for ASP.NET.
  /// </summary>
  public class NamespaceDoc {
  }

  //------------------------------------------------------------------------------------------07.11.2004
  /// <summary>ASP HelloWorld Sample: The script in HelloWorld.aspx creates the PDF document (without code-behind file)</summary>
  public class HelloWorld : Report {
    //------------------------------------------------------------------------------------------07.11.2004
    /// <summary>Creates this report.</summary>
    /// <remarks>
    /// The method <see cref="Root.Reports.Report.Create"/> of base class <see cref="Root.Reports.Report"/> must
    /// be overridden to create the contents of the report.
    /// </remarks>
    protected override void Create() {
    }

    //------------------------------------------------------------------------------------------08.11.2004
    /// <summary>Occurs when the page will be loaded.</summary>
    /// <remarks>
    /// This method calls <see cref="Root.Reports.RT.ResponsePDF">RT.ResponsePDF</see> that will create the PDF response stream.
    /// </remarks>
    protected void Page_Load() {
    }
  }

  //------------------------------------------------------------------------------------------08.11.2004
  /// <summary>ASP Table Layout Manager and ADO.NET Sample: The script in TableLayoutManagerSamplePage.aspx calls TableLayoutManagerSample.cs of the SamplesDLL (without code-behind file)</summary>
  public class TableLayoutManagerSamplePage {
    //------------------------------------------------------------------------------------------08.11.2004
    /// <summary>Occurs when the page will be loaded.</summary>
    /// <remarks>
    /// This method calls <see cref="Root.Reports.RT.ResponsePDF">RT.ResponsePDF</see> that will create the PDF response stream.
    /// </remarks>
    protected void Page_Load() {
    }
  }
}
